--
-- self
-- for all self
--
-- @author by Boembchen
-- @date  08/06/09
--
-- Copyright (C) 

MB1800SaddleTrac = {};

function MB1800SaddleTrac.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function MB1800SaddleTrac:load(xmlFile)

    self.rundumleuchtenAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.rundumleuchten#count"),0);
    self.rundumleuchtenAn = false;
    self.rundumleuchten = {};
    for i=1, self.rundumleuchtenAnz do
        local objname = string.format("vehicle.rundumleuchten.light" .. "%d",i);
        self.rundumleuchten[i] = {};
        self.rundumleuchten[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.rundumleuchten[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.rundumleuchten[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.rundumleuchten[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.rundumleuchten[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.rundumleuchten[i].emit and self.rundumleuchten[i].source ~= nil then
           setVisibility(self.rundumleuchten[i].source, false);
        end;
    end;
	
--[[Arbeitslicht Vorne start]]--
    self.numFrontlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.frontlights#count"), 0);
    self.frontlights = {};
    for i=1, self.numFrontlights do
        local frontlightnamei = string.format("vehicle.frontlights.frontlight" .. "%d", i);
        self.frontlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, frontlightnamei .. "#index"));
        setVisibility(self.frontlights[i], false);
    end;	
	self.frontlightsActive = false;	
--[[Arbeitslicht Vorne ende]]--

--[[Fernlicht start]]--
    self.numFarlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.farlights#count"), 0);
    self.farlights = {};
    for i=1, self.numFarlights do
        local farlightnamei = string.format("vehicle.farlights.farlight" .. "%d", i);
        self.farlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, farlightnamei .. "#index"));
        setVisibility(self.farlights[i], false);
    end;	
	self.farlightsActive = false;	
--[[Fernlicht ende]]--

--[[Arbeitslicht Hinten start]]--
    self.numBacklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.backlights#count"), 0);
    self.backlights = {};
    for i=1, self.numBacklights do
        local backlightnamei = string.format("vehicle.backlights.backlight" .. "%d", i);
        self.backlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, backlightnamei .. "#index"));
        setVisibility(self.backlights[i], false);
    end;	
	self.backlightsActive = false;	
--[[Arbeitslicht Hinten ende]]--	
	
	self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
    self.brakelights = {};
    for i=1, self.numbrakelights do
        local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
        self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
        setVisibility(self.brakelights[i], false);
    end;
	self.brakelightsActive = false;
    self.braking = false;
	
	local radioSound = getXMLString(xmlFile, "vehicle.radioSound#file");
    if  radioSound ~= nil and  radioSound ~= "" then
        radioSound = Utils.getFilename( radioSound, self.baseDirectory); 
        self.radioSound = createSample(" radioSound");
        self.radioSoundPlaying = false;
        loadSample(self. radioSound, radioSound, false);
        self.radioSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.radioSound#volume"),1);
    end;
	
	local brakeSound = getXMLString(xmlFile, "vehicle.brakeSound#file");
    if brakeSound ~= nil and brakeSound ~= "" then
	brakeSound = Utils.getFilename(brakeSound, self.baseDirectory);
        self.brakeSound = createSample("brakeSound");
        loadSample(self.brakeSound, brakeSound, false);
    end;
	
	local handbrakeSound = getXMLString(xmlFile, "vehicle.handbrakeSound#file");
    if handbrakeSound ~= nil and handbrakeSound ~= "" then
	handbrakeSound = Utils.getFilename(handbrakeSound, self.baseDirectory);
        self.handbrakeSound = createSample("handbrakeSound");
        loadSample(self.handbrakeSound, handbrakeSound, false);
    end;
	
	local compressorSound = getXMLString(xmlFile, "vehicle.compressorSound#file");
    if compressorSound ~= nil and compressorSound ~= "" then
	compressorSound = Utils.getFilename(compressorSound, self.baseDirectory);
        self.compressorSound = createSample("compressorSound");
        loadSample(self.compressorSound, compressorSound, false);
    end;
	
	local compressorStopSound = getXMLString(xmlFile, "vehicle.compressorStopSound#file");
    if compressorStopSound ~= nil and compressorStopSound ~= "" then
	compressorStopSound = Utils.getFilename(compressorStopSound, self.baseDirectory);
        self.compressorStopSound = createSample("compressorStopSound");
        loadSample(self.compressorStopSound, compressorStopSound, false);
    end;
	
    local rotationPartNodeWischer = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartWischer#index"));
    if rotationPartNodeWischer ~= nil then
        self.rotationPartWischer = {};
        self.rotationPartWischer.node = rotationPartNodeWischer;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischer#minRot"));
        self.rotationPartWischer.minRot = {};
        self.rotationPartWischer.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischer.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischer.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischer#maxRot"));
        self.rotationPartWischer.maxRot = {};
        self.rotationPartWischer.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischer.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischer.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartWischer.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischer#rotTime"), 2)*1000;
        self.rotationPartWischer.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischer#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeWischerblatt = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#index"));
    if rotationPartNodeWischerblatt ~= nil then
        self.rotationPartWischerblatt = {};
        self.rotationPartWischerblatt.node = rotationPartNodeWischerblatt;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#minRot"));
        self.rotationPartWischerblatt.minRot = {};
        self.rotationPartWischerblatt.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischerblatt.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischerblatt.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#maxRot"));
        self.rotationPartWischerblatt.maxRot = {};
        self.rotationPartWischerblatt.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartWischerblatt.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartWischerblatt.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartWischerblatt.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#rotTime"), 2)*1000;
        self.rotationPartWischerblatt.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartWischerblatt#touchRotLimit"), 10));
    end;
	
	-- Armaturenbrett
	local rotationPartNodeKmh1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartKmh1#index"));
    if rotationPartNodeKmh1 ~= nil then
        self.rotationPartKmh1 = {};
        self.rotationPartKmh1.node = rotationPartNodeKmh1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh1#minRot"));
        self.rotationPartKmh1.minRot = {};
        self.rotationPartKmh1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh1#maxRot"));
        self.rotationPartKmh1.maxRot = {};
        self.rotationPartKmh1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartKmh1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh1#rotTime"), 2)*1000;
        self.rotationPartKmh1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh1#touchRotLimit"), 10));
    end;

	local rotationPartNodeKmh2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartKmh2#index"));
    if rotationPartNodeKmh2 ~= nil then
        self.rotationPartKmh2 = {};
        self.rotationPartKmh2.node = rotationPartNodeKmh2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh2#minRot"));
        self.rotationPartKmh2.minRot = {};
        self.rotationPartKmh2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartKmh2#maxRot"));
        self.rotationPartKmh2.maxRot = {};
        self.rotationPartKmh2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartKmh2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartKmh2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartKmh2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh2#rotTime"), 2)*1000;
        self.rotationPartKmh2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartKmh2#touchRotLimit"), 10));
    end;

	local rotationPartNodeTanknadel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTanknadel#index"));
    if rotationPartNodeTanknadel ~= nil then
        self.rotationPartTanknadel = {};
        self.rotationPartTanknadel.node = rotationPartNodeTanknadel;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#minRot"));
        self.rotationPartTanknadel.minRot = {};
        self.rotationPartTanknadel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#maxRot"));
        self.rotationPartTanknadel.maxRot = {};
        self.rotationPartTanknadel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartTanknadel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#rotTime"), 2)*1000;
        self.rotationPartTanknadel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel#touchRotLimit"), 10));
    end;
	
	self.incrementRotation = true;
    self.exhaustCover = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.exhaustCover#index"));
    if self.exhaustCover ~= nil then
        self.exhaustRotationSpeed = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.exhaustCover#rotationSpeed"), 0);
		self.exhaustRotationMax = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.exhaustCover#rotationMax"), 0);
		self.exhaustRotationMin = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.exhaustCover#rotationMin"), 0);
		self.currentRotation = self.exhaustRotationMin;
    end;
	
	local rotationNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation11#index"));
        self.rotation11 = {};
        self.rotation11.node = rotationNode11;

	local rotationNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation12#index"));
        self.rotation12 = {};
        self.rotation12.node = rotationNode12;
		  
	local rotationNode13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation13#index"));
        self.bottomArm2 = {};
        self.bottomArm2.node = rotationNode13;
		  
	local rotationPartNodeTanknadel2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#index"));
    if rotationPartNodeTanknadel2 ~= nil then
        self.rotationPartTanknadel2 = {};
        self.rotationPartTanknadel2.node = rotationPartNodeTanknadel2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#minRot"));
        self.rotationPartTanknadel2.minRot = {};
        self.rotationPartTanknadel2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#maxRot"));
        self.rotationPartTanknadel2.maxRot = {};
        self.rotationPartTanknadel2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartTanknadel2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartTanknadel2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartTanknadel2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#rotTime"), 2)*1000;
        self.rotationPartTanknadel2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartTanknadel2#touchRotLimit"), 10));
    end;

	local rotationPartNodeDruck = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDruck#index"));
    if rotationPartNodeDruck ~= nil then
        self.rotationPartDruck = {};
        self.rotationPartDruck.node = rotationPartNodeDruck;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruck#minRot"));
        self.rotationPartDruck.minRot = {};
        self.rotationPartDruck.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruck.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruck.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruck#maxRot"));
        self.rotationPartDruck.maxRot = {};
        self.rotationPartDruck.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruck.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruck.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartDruck.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruck#rotTime"), 2)*1000;
        self.rotationPartDruck.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruck#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeDruckLight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDruckLight#index"));
    if rotationPartNodeDruckLight ~= nil then
        self.rotationPartDruckLight = {};
        self.rotationPartDruckLight.node = rotationPartNodeDruckLight;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#minRot"));
        self.rotationPartDruckLight.minRot = {};
        self.rotationPartDruckLight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruckLight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruckLight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#maxRot"));
        self.rotationPartDruckLight.maxRot = {};
        self.rotationPartDruckLight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDruckLight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDruckLight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartDruckLight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#rotTime"), 2)*1000;
        self.rotationPartDruckLight.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDruckLight#touchRotLimit"), 10));
    end;
	
     local rotationPartNodeDrehzahl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#index"));
    if rotationPartNodeDrehzahl1 ~= nil then
        self.rotationPartDrehzahl1 = {};
        self.rotationPartDrehzahl1.node = rotationPartNodeDrehzahl1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#minRot"));
        self.rotationPartDrehzahl1.minRot = {};
        self.rotationPartDrehzahl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#maxRot"));
        self.rotationPartDrehzahl1.maxRot = {};
        self.rotationPartDrehzahl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartDrehzahl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#rotTime"), 2)*1000;
        self.rotationPartDrehzahl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl1#touchRotLimit"), 10));
    end;

	local rotationPartNodeDrehzahl2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#index"));
    if rotationPartNodeDrehzahl2 ~= nil then
        self.rotationPartDrehzahl2 = {};
        self.rotationPartDrehzahl2.node = rotationPartNodeDrehzahl2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#minRot"));
        self.rotationPartDrehzahl2.minRot = {};
        self.rotationPartDrehzahl2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#maxRot"));
        self.rotationPartDrehzahl2.maxRot = {};
        self.rotationPartDrehzahl2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartDrehzahl2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartDrehzahl2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartDrehzahl2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#rotTime"), 2)*1000;
        self.rotationPartDrehzahl2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartDrehzahl2#touchRotLimit"), 10));
    end;
	
	local rotationPartNodebackwindow = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.backwindow#index"));
    if rotationPartNodebackwindow ~= nil then
        self.rotationPartbackwindow = {};
        self.rotationPartbackwindow.node = rotationPartNodebackwindow;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartbackwindow#minRot"));
        self.rotationPartbackwindow.minRot = {};
        self.rotationPartbackwindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.backwindow#maxRot"));
        self.rotationPartbackwindow.maxRot = {};
        self.rotationPartbackwindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartbackwindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.backwindow#rotTime"), 2)*1000;
        self.rotationPartbackwindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.backwindow#touchRotLimit"), 10));
    end;

    local rotationPartNodefrontwindow = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.frontwindow#index"));
    if rotationPartNodefrontwindow ~= nil then
        self.rotationPartfrontwindow = {};
        self.rotationPartfrontwindow.node = rotationPartNodefrontwindow;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartfrontwindow#minRot"));
        self.rotationPartfrontwindow.minRot = {};
        self.rotationPartfrontwindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartfrontwindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartfrontwindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.frontwindow#maxRot"));
        self.rotationPartfrontwindow.maxRot = {};
        self.rotationPartfrontwindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartfrontwindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartfrontwindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));
        self.rotationPartfrontwindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.frontwindow#rotTime"), 2)*1000;
        self.rotationPartfrontwindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.frontwindow#touchRotLimit"), 10));
    end;
	
    self.motorStopSoundVolume2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.motorStopSound#volume"), 1.0);
    hornSoundFile = Utils.getFilename("Sounds/horn.wav", self.baseDirectory);
    self.hornSoundId = createSample("HupenSound");
    loadSample(self.hornSoundId, hornSoundFile, false);
    
	self.exhaustParticleLow = {};
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleLow, "vehicle.exhaustParticleLow", self.rootNode, false, nil, self.baseDirectory);
    self.exhaustParticleHigh = {};
    Utils.loadParticleSystem(xmlFile, self.exhaustParticleHigh, "vehicle.exhaustParticleHigh", self.rootNode, false, nil, self.baseDirectory);
    
--[[Blinker start]]------------------------------------------------------------	
	turn1SoundFile = Utils.getFilename("Sounds/turn1.wav", self.baseDirectory);
    self.turn1 = createSample("turn1");
    loadSample(self.turn1, turn1SoundFile, false);
	turn2SoundFile = Utils.getFilename("Sounds/turn2.wav", self.baseDirectory);
    self.turn2 = createSample("turn2");
    loadSample(self.turn2, turn2SoundFile, false);	
	
    self.numTurnlights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.turnlights#count"), 0);
    self.turnlights = {};
    for i=1, self.numTurnlights do
        local turnlightnamei = string.format("vehicle.turnlights.turnlight" .. "%d", i);
        self.turnlights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, turnlightnamei .. "#index"));
        setVisibility(self.turnlights[i], false);
    end;	
	self.turnlightsActive = false;
	
    self.numTurnlights2 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.turnlights2#count"), 0);
    self.turnlights2 = {};
    for i=1, self.numTurnlights2 do
        local turnlightnamei2 = string.format("vehicle.turnlights2.turnlight" .. "%d", i);
        self.turnlights2[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, turnlightnamei2 .. "#index"));
        setVisibility(self.turnlights2[i], false);
    end;	
	self.turnlightsActive2 = false;
--[[Blinker ende]]------------------------------------------------------------	

--[[Wheelchange start]]--
	self.numTerraWheels = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.terraWheels#count"), 0);
    self.terraWheels = {};
    for i=1, self.numTerraWheels do
        local terraWheelnamei = string.format("vehicle.terraWheels.terraWheel" .. "%d", i);
        self.terraWheels[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, terraWheelnamei .. "#index"));
        setVisibility(self.terraWheels[i], false);
    end;
    self.terraWheelsActive= false;	
    self.Nwheels = {};
    self.Nwheels[1] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Nwheels.Nwheel1#index"));
    self.Nwheels[2] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Nwheels.Nwheel2#index"));
    self.Nwheels[3] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Nwheels.Nwheel3#index"));	
    self.Nwheels[4] = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Nwheels.Nwheel4#index"));
    self.drawNwheel = getVisibility(self.Nwheels[1])	
--[[Wheelschange ende]]--	

    self.keys = {};
    local i=0;
    while true do
        local baseName = string.format("vehicle.keys.input(%d)", i);
        local inputName = getXMLString(xmlFile, baseName.. "#name");
        if inputName == nil then
            break;
        end;
        local inputKey = getXMLString(xmlFile, baseName.. "#key");
        if Input[inputKey] == nil then
            print("Error: invalid key '" .. inputKey .. "'  for input event '" .. inputName .. "'");
            break;
        end;
        self.keys[inputName] = Input[inputKey];
        i = i+1;
    end;
	
	self.brakeOn = false;
	self.lightsbrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.brake#index"));
	self.druckl_green = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.druckl_green#index"));
    self.druckl_red = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.druckl_red#index"));
	self.lightsfuelwarn = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.fuelwarn#index"));
	self.lightshandbrake = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.handbrake#index"));
	self.lightsradio = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.extra_lights.radio#index"));
	self.frontlights.outs = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.frontlights.frontlight#src"));
	self.fuelWarnSoundRunning = false;
	self.handbrakeSoundRunning = false;
    self.maxRpm1 = self.motor.maxRpm[1];
    self.maxRpm2 = self.motor.maxRpm[2];
    self.maxRpm3 = self.motor.maxRpm[3];
    self.brakeForce = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.brakeForce"), 10);
    self.motorBrakeForce = self.motor.brakeForce;
	self.druckLevel = 6500;
	self.farlightsActive = false;
    self.frontlightsActive = false;
	self.worklightsActive = false;
    self.hornPlaying = false;
    self.zuendungKey = false;
	self.allowedZuendung = false; 
    self.compressorStart = false;
	self.brakeSoundRunning = true;
	self.revLimit = 100;
    self.delayWischer1 = 0;
	self.delayWischer2 = 0;
	self.compressor = false;
	
	self.keyType = InputBinding.getButtonKeyName;
	self.keyName = "";
end;

function MB1800SaddleTrac:keyEvent(unicode, sym, modifier, isDown)

	self.keyType = InputBinding.getButtonKeyName;
	self.keyName = "";

    if InputBinding.isPressed(InputBinding.MBSTracLIGHTHELP) then
		self.LichtMBStrac = not self.LichtMBStrac;
	end;		
    if InputBinding.isPressed(InputBinding.MBSTracRULLIGHT) then
		self.rundumleuchtenAn = not self.rundumleuchtenAn;
		for i=1, self.rundumleuchtenAnz do
			setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
		end;
    end;
--[[Arbeitslicht/Rckfahrlicht start]]--
	if InputBinding.isPressed(InputBinding.MBSTracFRONTWORKLIGHT) then	
		self.frontlightsActive = not self.frontlightsActive;
		self.farlightsActive = false;
		self.backlightsActive = false;
	end;

	if InputBinding.isPressed(InputBinding.MBSTracFARLIGHT) then	
		self.farlightsActive = not self.farlightsActive;
		self.frontlightsActive = false;
		self.backlightsActive = false;
	end;

	if InputBinding.isPressed(InputBinding.MBSTracBACKWORKLIGHT) then	
		self.backlightsActive = not self.backlightsActive;
		self.farlightsActive = false;		
		self.frontlightsActive = false;		
	end;
--[[Arbeitslicht/Rckfahrlicht ende]]--	
--[[Blinker start]]------------------------------------------------------------	
--[[Blinker Rechts]]-----------------------------------------------------------
	if InputBinding.isPressed(InputBinding.MBSTracTURNRIGHTLIGHT) then
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.flashlightsRightActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsRight2Active = false;
		self.turnlightsActive2 = false;
		self.flashWarner = false;
	end;
--[[Warnblinker]]------------------------------------------------------------	
	if InputBinding.isPressed(InputBinding.MBSTracWARNLIGHT) then
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.flashlightsRightActive = false;
		self.flashlightsLeftActive = false;
		self.flashWarner = not self.flashWarner;
	end;
--[[Blinker Links]]-----------------------------------------------------------
	if InputBinding.isPressed(InputBinding.MBSTracTURNLEFTLIGHT) then
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.flashlightsLeftActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsLeft2Active = false;
		self.turnlightsActive = false;
		self.flashWarner = false;
	end;	
--[[Blinker ende]]------------------------------------------------------------	
	
    if InputBinding.isPressed(InputBinding.MBSTracHELP) then
		self.helpMBStrac = not self.helpMBStrac;
	end;
    if InputBinding.isPressed(InputBinding.MBSTracBACKWINDOW) then 
		self.rotationMaxbackwindow = not self.rotationMaxbackwindow;
	end; 
    if InputBinding.isPressed(InputBinding.MBSTracFRONTWINDOW) then 
		self.rotationMaxfrontwindow = not self.rotationMaxfrontwindow;
	end; 
	if InputBinding.isPressed(InputBinding.MBSTracBRAKE) then
		self.handbrake = not self.handbrake;
	end;	

--[[Wheelschange start]]--	
	if InputBinding.isPressed(InputBinding.MBSTracTERRA) then 
		self.terraWheelsActive = not self.terraWheelsActive;
	end;
    if InputBinding.isPressed(InputBinding.MBSTracTERRA) then
    	self.drawNwheel = not self.drawNwheel;
    	setVisibility(self.Nwheels[1], self.drawNwheel);
    	setVisibility(self.Nwheels[2], self.drawNwheel);
    	setVisibility(self.Nwheels[3], self.drawNwheel);
    	setVisibility(self.Nwheels[4], self.drawNwheel);		
    end;	
--[[Wheelchange ende]]--
end;


function MB1800SaddleTrac:update(dt)
    if self.isEntered then
	    if self.rotationPartbackwindow ~= nil then
		   local x, y, z = getRotation(self.rotationPartbackwindow.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartbackwindow.maxRot, self.rotationPartbackwindow.minRot, 3, self.rotationPartbackwindow.rotTime, dt, not self.rotationMaxbackwindow);
		   setRotation(self.rotationPartbackwindow.node, unpack(newRot));
        end;
    
	    if self.rotationPartfrontwindow ~= nil then
		   local x, y, z = getRotation(self.rotationPartfrontwindow.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartfrontwindow.maxRot, self.rotationPartfrontwindow.minRot, 3, self.rotationPartfrontwindow.rotTime, dt, not self.rotationMaxfrontwindow);
		   setRotation(self.rotationPartfrontwindow.node, unpack(newRot));
        end;
		
	    if self.rotation11.node ~= nil and self.bottomArm2.node ~= nil then
			rBBArmX, rBBArmY, rBBArmZ = getRotation(self.bottomArm2.node);
			setRotation(self.rotation11.node, rBBArmX*1.5-0.35, 0, 0);
        end;
	    if self.rotation12.node ~= nil and self.bottomArm2.node ~= nil then
			setRotation(self.rotation12.node, 0.278-rBBArmX*1.4, 0, 0);
        end;
	end;
--[[Arbeitslicht Vorne start]]----------------------------------------
	   if self.frontlightsActive then
			for i=1, self.numFrontlights do
				local frontlight = self.frontlights[i];
				setVisibility(frontlight, self.frontlightsActive);
			end;
		else
			for i=1, self.numFrontlights do
				local frontlight = self.frontlights[i];
				setVisibility(frontlight, self.frontlightsActive, false);
			end;
		end;	
--[[Arbeitslicht Vorne ende]]------------------------------------------

--[[Fernlicht start]]----------------------------------------
	   if self.farlightsActive then
			for i=1, self.numFarlights do
				local farlight = self.farlights[i];
				setVisibility(farlight, self.farlightsActive);
			end;
		else
			for i=1, self.numFarlights do
				local farlight = self.farlights[i];
				setVisibility(farlight, self.farlightsActive, false);
			end;
		end;	
--[[Fernlicht ende]]------------------------------------------

--[[Arbeitslicht/Rckfahrlicht start]]----------------------------------------
	   if self.backlightsActive then
			for i=1, self.numBacklights do
				local backlight = self.backlights[i];
				setVisibility(backlight, self.backlightsActive);
			end;
		else
			for i=1, self.numBacklights do
				local backlight = self.backlights[i];
				setVisibility(backlight, self.backlightsActive, false);
			end;
		end;	
--[[Arbeitslicht/Rckfahrlicht ende]]--
		
        if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.hasEvent(InputBinding.MBSTracRADIO) then
            if not self.radioSoundPlaying then 
				playSample(self. radioSound, 0, self. radioSoundVolume, 0); 
				self.radioSoundPlaying = true; 
				setVisibility(self.lightsradio, true);
			else 
                stopSample(self. radioSound); 
                self.radioSoundPlaying = false; 
				setVisibility(self.lightsradio, false);
            end;  
        end;
		  
		if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.isPressed(InputBinding.MBSTracHUPE) then
			if not self.hornPlaying then
				playSample(self.hornSoundId, 0, 1, 0);
				self.hornPlaying = true;
			end;
		else
			if self.hornPlaying then
				stopSample(self.hornSoundId);
				self.hornPlaying = false;
			end;
		end;

        if self.rundumleuchtenAn then
			for i=1, self.rundumleuchtenAnz do
				rotate(self.rundumleuchten[i].rotNode, 0, dt*self.rundumleuchten[i].speed, 0);
			end;
        end;
        
	if g_currentMission.environment ~= nil and g_currentMission.environment.dayNightCycle and
        (g_currentMission.environment.dayTime > (20.5*1000*60*60) or g_currentMission.environment.dayTime < (5.5*1000*60*60)) and
        not self.lightsActive and self.isHired and not self.steeringEnabled then
		self.lightsActive = true;
	end;

	if not self.isHired and self.lightsActive and not self.isEntered or not g_currentMission.environment.dayNightCycle then
		self.lightsActive = false;
	end;


    for k, light in pairs(self.lights) do
        setVisibility(light, self.lightsActive);
    end; 
    

    if not self.isAITractorActivated then
        if self:getIsActiveForInput() then
            if InputBinding.hasEvent(InputBinding.MBSTracZUENDUNG) then
		        self.zuendungKey = not self.zuendungKey;
			    self.allowedZuendung = true;
	        end;
	    end;
	    if not self.allowedZuendung and  not self.zuendungKey then
            self.isMotorStarted = false;
            Motorized.stopSounds(self);
	        self.steeringEnabled = false;
            Utils.setEmittingState(self.exhaustParticleSystems, false)
	    end;
	    if not self.zuendungKey then
	        self.motorStopSoundVolume = 0;
        else
	        self.motorStopSoundVolume = self.motorStopSoundVolume2;
	    end;
	    if self.allowedZuendung then
	        if  not self.zuendungKey then
		        self.motorStopSoundVolume = self.motorStopSoundVolume2;
                self:stopMotor();
			    self.steeringEnabled = false;
                self.allowedZuendung = false;	
		        setVisibility(self.druckl_red, false);
		        setVisibility(self.druckl_green, false);	
				self.compressor = false ;
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, self.motor.brakeForce, 0);
                end;
                self:onDeactivateAttachements();
	        elseif self.zuendungKey then
                self:startMotor();
                self.steeringEnabled = true;
                self.allowedZuendung = false;
		        setVisibility(self.druckl_red, true);
		        setVisibility(self.druckl_green, true);	
				self.compressor = true ;
       	    end;
	    end;
    elseif not self.zuendungKey and not self.deactivateOnLeave then
		self:stopAITractor();
	end;

--[[Blinker start]]------------------------------------------------------------
	    if self.flash then
		    if self.delayOn >= 0 then
			    self.delayOn = self.delayOn -dt;
		    end;
		    if not self.flashlightsRightActive then
			    if self.delayOn < 0 then
				    self.delayOff = 500;
				    self.flashlightsRightActive = true;
				    self.flashlightsLeftActive = true;
			    	self.flashlightsWarnerActive = true;
				    self.turnlightsActive2 = true;
			    	self.turnlightsActive = true;
				    playSample(self.turn1, 1, 0.7, 0);
			    end;
		    end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				self.flashlightsLeftActive = false;
				self.flashlightsRightActive = false;
				self.flashlightsWarnerActive = false;
				self.turnlightsActive2 = false;
				self.turnlightsActive = false;
				playSample(self.turn2, 1, 0.7, 0);
			end;
		end;
	  end;

	    if self.flashRight then
		    if self.delayOnRight >= 0 then
			    self.delayOnRight = self.delayOnRight -dt;
		    end;
		    if not self.flashlightsRightActive then
			    if self.delayOnRight < 0 then
				    self.delayOffRight = 500;
				    self.flashlightsRightActive = true;
				    self.turnlightsActive2 = true;
				    playSample(self.turn1,1,0.7,0);
			    end;
		    end;
		    if self.delayOffRight >= 0 then
			   self.delayOffRight = self.delayOffRight -dt;
		    end;
		    if self.flashlightsRightActive then
			    if self.delayOffRight < 0 then
				    self.delayOnRight = 500;
				    self.flashlightsRightActive = false;
				    self.turnlightsActive2 = false;
				    playSample(self.turn2,1,0.7,0);
			    end;
		    end;
	    else
		    if not self.flashWarner then
			    self.turnlightsActive2 = false;
		    end;
	    end;

		if self.flashLeft then
			if self.delayOnLeft >= -1 then
				self.delayOnLeft = self.delayOnLeft -dt;
			end;
			if not self.flashlightsLeftActive then
				if self.delayOnLeft < 0 then
					self.delayOffLeft = 500;
					self.flashlightsLeftActive = true;
					self.turnlightsActive = true;
					playSample(self.turn1,1,0.7,0);
				end;
			end;
			if self.delayOffLeft >= 0 then
				self.delayOffLeft = self.delayOffLeft -dt;
			end;
			if self.flashlightsLeftActive then
				if self.delayOffLeft < 0 then
					self.delayOnLeft = 500;
					self.flashlightsLeftActive = false;
					self.turnlightsActive = false;
					playSample(self.turn2,1,0.7,0);
				end;
			end;
		else
			if not self.flashWarner then
				self.turnlightsActive = false;
			end;
		end;

		if self.turnlightsActive then
			for i=1, self.numTurnlights do
				local turnlight = self.turnlights[i];
				setVisibility(turnlight, self.turnlightsActive);
			end;
		else
			for i=1, self.numTurnlights do
				local turnlight = self.turnlights[i];
				setVisibility(turnlight, self.turnlightsActive, false);
			end;
		end;
    	if self.turnlightsActive2 then
			for i=1, self.numTurnlights2 do
				local turnlight2 = self.turnlights2[i];
				setVisibility(turnlight2, self.turnlightsActive2);
			end;
		else
			for i=1, self.numTurnlights2 do
				local turnlight2 = self.turnlights2[i];
				setVisibility(turnlight2, self.turnlightsActive2, false);
			end;
		end;
	
--[[Blinker ende]]------------------------------------------------------------
    if self.compressor or self.isHired then 
		if self.druckLevel >= -1 and self.druckLevel <= 6000 then
			self.compressorStart = true;
		end;
		if self.druckLevel >= 9999 then
			self.compressorStart = false;
		end;
		if self.compressorStart == true then
			if not self.compressorSoundRunning then
				playSample(self.compressorSound, 0, 1, 0);
				self.compressorSoundRunning = true;
			end;
			self.compressorStopSoundRunning = false;
			if self.druckLevel <= 10000 then
				self.druckLevel = self.druckLevel +(dt/3);
			end;
		end;
		if self.compressorStart == false then
			stopSample(self.compressorSound, 0, 1, 0);
			self.compressorSoundRunning = false;
			if not self.compressorStopSoundRunning then
				playSample(self.compressorStopSound, 1, 1, 0);
				self.compressorStopSoundRunning = true;
			end;

		end;
		if self.compressor then
			if self.druckLevel <= 6100 then
				self.druckWarning = true;
				setVisibility(self.druckl_red, true);
			else
				self.druckWarning = false;
				self.druckWarnlightsActive = false;
				setVisibility(self.druckl_red, false);			
			end;
			if self.druckLevel >= 6000 then
				self.drucklightsActive = true;
				setVisibility(self.druckl_green, true);			
			else
				self.drucklightsActive = false;
				setVisibility(self.druckl_green, false);	
			end;
		end;
       
		local fuelWarn = 75;
		if self.fuelFillLevel < fuelWarn then
	       setVisibility(self.lightsfuelwarn, true);
		else
	       setVisibility(self.lightsfuelwarn, false);
		end;

	 
        inputAxisY = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);

        if InputBinding.isAxisZero(inputAxisY) then
        inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
        end;
		
        if Input.isKeyPressed(self.keys.rev_up) and self.revLimit < 100 then
          self.revLimit = self.revLimit + 1;
        elseif Input.isKeyPressed(self.keys.rev_down) and self.revLimit > 10 then
          self.revLimit = self.revLimit - 1;
        end;

        

        self.motor.maxRpm[1] = string.format("%d",(self.revLimit * self.maxRpm1 / 100));
        self.motor.maxRpm[2] = string.format("%d",(self.revLimit * self.maxRpm2 / 100));
        self.motor.maxRpm[3] = string.format("%d",(self.revLimit * self.maxRpm3 / 100));


	if self.isEntered then
		if (self.movingDirection*self.lastSpeed*(-inputAxisY)) < -0.001 then
			setVisibility(self.lightsbrake, true);
			if self.druckLevel >= 5500 then
				self.motor.brakeForce = self.motorBrakeForce;
				if not self.brakeSoundRunning then
					playSample(self.brakeSound, 1, 1, 0);
					self.brakeSoundRunning = true;
				end;
			end;
			if not self.braking then
				if self.druckLevel > 0 then
					self.druckLevel = self.druckLevel -350;
				end;
				self.braking = true;
			end;
		else
			if not self.handbrake then
				self.motor.brakeForce = self.motor.brakeForce*0;
			end;
	        setVisibility(self.lightsbrake, false);
			self.braking = false;
			if self.druckLevel >= 5500 then
				self.brakeSoundRunning = false;
			end;
		end;
        if g_currentMission.attachableInMountRange ~= nil then
            self.motor.brakeForce = self.brakeForce;
        end;
		if self.handbrake then
			self.motor.brakeForce = self.brakeForce;
			self.motor.maxRpm[1] = 0;
			self.motor.maxRpm[2] = 0;
			self.motor.maxRpm[3] = 0;
			setVisibility(self.lightshandbrake, self.handbrake);
			if not self.handbrakeSoundRunning then
				playSample(self.handbrakeSound, 1, 1, 0);
				self.handbrakeSoundRunning = true;
			end;
		else
			setVisibility(self.lightshandbrake, false);
			self.handbrakeSoundRunning = false;
		end;
	end;
 end;
 
    local maxKmh = 50;
	if self.rotationPartKmh1 ~= nil then
		local x, y, z = getRotation(self.rotationPartKmh1.node);
		y = ((self.rotationPartKmh1.maxRot[2] - self.rotationPartKmh1.minRot[2]) / maxKmh) * self.lastSpeed*3600 + self.rotationPartKmh1.minRot[2];
		setRotation(self.rotationPartKmh1.node, x, y ,z);
	end;
	if self.rotationPartKmh2 ~= nil then
		local x, y, z = getRotation(self.rotationPartKmh2.node);
		y = ((self.rotationPartKmh2.maxRot[2] - self.rotationPartKmh2.minRot[2]) / maxKmh) * self.lastSpeed*3600 + self.rotationPartKmh2.minRot[2];
		setRotation(self.rotationPartKmh2.node, x, y ,z);
	end;

	if self.rotationPartTanknadel ~= nil then
		local x, y, z = getRotation(self.rotationPartTanknadel.node);
		y = ((self.rotationPartTanknadel.maxRot[2] - self.rotationPartTanknadel.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel.minRot[2];
		setRotation(self.rotationPartTanknadel.node, x, y ,z);
	end;
	
	if self.rotationPartTanknadel2 ~= nil then
		local x, y, z = getRotation(self.rotationPartTanknadel2.node);
		y = ((self.rotationPartTanknadel2.maxRot[2] - self.rotationPartTanknadel2.minRot[2]) / self.fuelCapacity) * self.fuelFillLevel + self.rotationPartTanknadel2.minRot[2];
		setRotation(self.rotationPartTanknadel2.node, x, y ,z);
	end;
	
	local maxDruck = 10000;
	if self.rotationPartDruck ~= nil then
		local x, y, z = getRotation(self.rotationPartDruck.node);
		y = ((self.rotationPartDruck.maxRot[2] - self.rotationPartDruck.minRot[2]) / maxDruck) * self.druckLevel + self.rotationPartDruck.minRot[2];
		setRotation(self.rotationPartDruck.node, x, y ,z);
	end;
	
	local maxDruckLight = 10000;
	if self.rotationPartDruckLight ~= nil then
		local x, y, z = getRotation(self.rotationPartDruckLight.node);
		y = ((self.rotationPartDruckLight.maxRot[2] - self.rotationPartDruckLight.minRot[2]) / maxDruckLight) * self.druckLevel + self.rotationPartDruckLight.minRot[2];
		setRotation(self.rotationPartDruckLight.node, x, y ,z);
	end;
	
    local maxDrehzahl = 1800;
	if self.rotationPartDrehzahl2 ~= nil then
	local x, y, z = getRotation(self.rotationPartDrehzahl2.node);
	y = ((self.rotationPartDrehzahl2.maxRot[2] - self.rotationPartDrehzahl2.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl2.minRot[2];
	setRotation(self.rotationPartDrehzahl2.node, x, y ,z);
	end;
	
	if self.rotationPartDrehzahl1 ~= nil then
		local x, y, z = getRotation(self.rotationPartDrehzahl1.node);
		y = ((self.rotationPartDrehzahl1.maxRot[2] - self.rotationPartDrehzahl1.minRot[2]) / maxDrehzahl) * self.motor.lastMotorRpm + self.rotationPartDrehzahl1.minRot[2];
		setRotation(self.rotationPartDrehzahl1.node, x, y ,z);
	end;
		 
    if self.isEntered then
		if g_currentMission.environment.lastRainScale <= 0.1 and g_currentMission.environment.timeSinceLastRain > 30 then
			self.rainWarning = false;
		else
			self.rainWarning = true;
		end;
		if self.rainWarning and self.isMotorStarted then
			if self.delayWischer1 >= 0 then
				self.delayWischer1 = self.delayWischer1 -dt;
			end;
			if self.delayWischer2 >= 0 then
				self.delayWischer2 = self.delayWischer2 -dt;
			end;
			if not self.rotationMaxWischer then
				if self.delayWischer1 < 0 then
					self.delayWischer2 = 1000;
					self.rotationMaxWischer = true;
					self.rotationMaxWischerblatt = true;
				end;
			end;
			if self.rotationMaxWischer then
				if self.delayWischer2 < 0 then
					self.delayWischer1 = 1000;
					self.rotationMaxWischer = false;
					self.rotationMaxWischerblatt = false;
				end;
			end;
		else
			self.rotationMaxWischer = false;
			self.rotationMaxWischerblatt = false;
		end;
	end;
	   
    if self.isHired or self.isMotorStarted then
		local rpm = math.max(self.motor.lastMotorRpm/50,0);
		local rpmDeltaMotion = math.max(self.motor.lastMotorRpm/300,0);
        if self.incrementRotation == true then 
       		self.currentRotation = self.currentRotation + self.exhaustRotationSpeed;
	 	else
			self.currentRotation = self.currentRotation - self.exhaustRotationSpeed;
	 	end;
	  	if self.currentRotation >= (self.exhaustRotationMax - rpmDeltaMotion)then
			self.incrementRotation = false;
	 	elseif self.currentRotation <= (self.exhaustRotationMin + rpmDeltaMotion) then
  			self.incrementRotation = true;
	  	end;
        setRotation(self.exhaustCover,Utils.degToRad(self.currentRotation+rpm), Utils.degToRad(180), 0);
	else 
		setRotation(self.exhaustCover, 0, Utils.degToRad(180), 0);
	end;
	
    if self.rotationPartWischer ~= nil then
		local x, y, z = getRotation(self.rotationPartWischer.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWischer.maxRot, self.rotationPartWischer.minRot, 3, self.rotationPartWischer.rotTime, dt, not self.rotationMaxWischer);
		setRotation(self.rotationPartWischer.node, unpack(newRot));
	end;  
    if self.rotationPartWischerblatt ~= nil then
		local x, y, z = getRotation(self.rotationPartWischerblatt.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartWischerblatt.maxRot, self.rotationPartWischerblatt.minRot, 3, self.rotationPartWischerblatt.rotTime, dt, not self.rotationMaxWischerblatt);
		setRotation(self.rotationPartWischerblatt.node, unpack(newRot));
	end;
	
    if self.isMotorStarted then
		if self.motor.lastMotorRpm > 200 and self.motor.lastMotorRpm < 1200 then
			Utils.setEmittingState(self.exhaustParticleLow, true);
        	Utils.setEmittingState(self.exhaustParticleHigh, false);
		else
			Utils.setEmittingState(self.exhaustParticleLow, false);
        	Utils.setEmittingState(self.exhaustParticleHigh, true);			
		end;
		if self.motor.lastMotorRpm > 1000 then
			Utils.setEmittingState(self.exhaustParticleLow, false);
        	Utils.setEmittingState(self.exhaustParticleHigh, true); 		
		else
			Utils.setEmittingState(self.exhaustParticleLow, true);
        	Utils.setEmittingState(self.exhaustParticleHigh, false); 
		end;
    else 
        Utils.setEmittingState(self.exhaustParticleLow, false);
        Utils.setEmittingState(self.exhaustParticleHigh, false); 
    end;

--[[Wheelchange start]]--	
	if self.terraWheelsActive then
		for i=1, self.numTerraWheels do
			local terraWheel = self.terraWheels[i];
			setVisibility(terraWheel, self.terraWheelsActive);
		end;
	else
		for i=1, self.numTerraWheels do
			local terraWheel = self.terraWheels[i];
			setVisibility(terraWheel, self.terraWheelsActive, false);
		end;
	end;
--[[Wheelchange ende]]--	
	
end; 

function MB1800SaddleTrac:draw()

    if self.isEntered then
		if not self.helpMBStrac then
			renderText(0.8335, 0.15, 0.017, self.keyName.. " " ..self.keyType(InputBinding.MBSTracHELP).. ": " ..g_i18n:getText("MBSTracHELP1"));
		else
			renderText(0.8335, 0.15, 0.017, self.keyName.. " " ..self.keyType(InputBinding.MBSTracHELP).. ": " ..g_i18n:getText("MBSTracHELP2"));
		end;
		if not self.LichtMBStrac then
			renderText(0.8335, 0.17, 0.017, self.keyName.. " " ..self.keyType(InputBinding.MBSTracLIGHTHELP).. ": " ..g_i18n:getText("MBSTracLichtanlage1"));
		else
			renderText(0.8335, 0.17, 0.017, self.keyName.. " " ..self.keyType(InputBinding.MBSTracLIGHTHELP).. ": " ..g_i18n:getText("MBSTracLichtanlage2"));
		end;
		if self.helpMBStrac then	
			renderText(0.72, 0.88, 0.021, "- MBSTrac Zusatz -");		
			renderText(0.72, 0.86, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracHUPE).. ": " ..g_i18n:getText("MBSTracHORN"));			
			if not self.rotationMaxfrontwindow then
				renderText(0.72, 0.845, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracFRONTWINDOW).. ": " ..g_i18n:getText("MBSTracFenster1"));
			else
				renderText(0.72, 0.845, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracFRONTWINDOW).. ": " ..g_i18n:getText("MBSTracFenster2"));
			end;			
			if not self.rotationMaxbackwindow then
				renderText(0.72, 0.83, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracBACKWINDOW).. ": " ..g_i18n:getText("MBSTracFenster3"));
			else
				renderText(0.72, 0.83, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracBACKWINDOW).. ": " ..g_i18n:getText("MBSTracFenster4"));
			end;			
			if not self.radioSoundPlaying then
				renderText(0.72, 0.815, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracRADIO).. ": " ..g_i18n:getText("MBSTracRADIO1"));
			else
				renderText(0.72, 0.815, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracRADIO).. ": " ..g_i18n:getText("MBSTracRADIO2"));
			end;			
			if not self.terraWheelsActive then
				renderText(0.72, 0.80, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracTERRA).. ": " ..g_i18n:getText("MBSTracTerra1"));
			else
				renderText(0.72, 0.80, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracTERRA).. ": " ..g_i18n:getText("MBSTracTerra2"));
			end;			
		end;
		if self.LichtMBStrac then	
			renderText(0.72, 0.765, 0.021, "- MBSTrac Beleuchtung -");		
			if not self.rundumleuchtenAn then
				renderText(0.72, 0.745, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracRULLIGHT).. ": " ..g_i18n:getText("MBSTracRundumleuchte1"));
			elseif self.rundumleuchtenAn then
				renderText(0.72, 0.745, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracRULLIGHT).. ": " ..g_i18n:getText("MBSTracRundumleuchte2"));
			end;
			if self.isMotorStarted then				
				if not self.frontlightsActive then
					renderText(0.72, 0.73, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracFRONTWORKLIGHT).. ": " ..g_i18n:getText("MBSTracArbeitslicht1")); 
				elseif self.frontlightsActive then
					renderText(0.72, 0.73, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracFRONTWORKLIGHT).. ": " ..g_i18n:getText("MBSTracArbeitslicht2"));
				end;
				if not self.farlightsActive then
					renderText(0.72, 0.715, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracFARLIGHT).. ": " ..g_i18n:getText("MBSTracArbeitslicht5")); 
				elseif self.farlightsActive then
					renderText(0.72, 0.715, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracFARLIGHT).. ": " ..g_i18n:getText("MBSTracArbeitslicht6"));
				end;
				if not self.backlightsActive then
					renderText(0.72, 0.70, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracBACKWORKLIGHT).. ": " ..g_i18n:getText("MBSTracArbeitslicht3")); 
				elseif self.backlightsActive then
					renderText(0.72, 0.70, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracBACKWORKLIGHT).. ": " ..g_i18n:getText("MBSTracArbeitslicht4"));
				end;
				if not self.flashLeft then --[[do not change......its flashlight right]]--
					renderText(0.72, 0.685, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracTURNRIGHTLIGHT).. ": " ..g_i18n:getText("MBSTracBlinkerrechts1")); 
				elseif self.flashLeft then --[[do not change......its flashlight right]]--
					renderText(0.72, 0.685, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracTURNRIGHTLIGHT).. ": " ..g_i18n:getText("MBSTracBlinkerrechts2"));
				end;
			end;
			if not self.flash then --[[do not change......its flashwarnlight]]--
				renderText(0.72, 0.67, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracWARNLIGHT).. ": " ..g_i18n:getText("MBSTracWarnblinker1")); 
			elseif self.flash then --[[do not change......its flashwarnlight]]--
				renderText(0.72, 0.67, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracWARNLIGHT).. ": " ..g_i18n:getText("MBSTracWarnblinker2"));
			end;
			if self.isMotorStarted then
				if not self.flashRight then --[[do not change......its flashlight left]]--
					renderText(0.72, 0.655, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracTURNLEFTLIGHT).. ": " ..g_i18n:getText("MBSTracBlinkerlinks1")); 
				elseif self.flashRight then --[[do not change......its flashlight left]]--
					renderText(0.72, 0.655, 0.02, self.keyName.. " " ..self.keyType(InputBinding.MBSTracTURNLEFTLIGHT).. ": " ..g_i18n:getText("MBSTracBlinkerlinks2"));
				end;
			end;
		end;		
	end;
	
	if self.handbrake then
		--setTextBold(true);
		--setTextColor(1,0,0,1);
		renderText(self.hudBasePoxX, 0.785, 0.02, "(!) Handbremse Aktiv");	
	end;
    if not self.isMotorStarted and not self.automaticStart then	
        g_currentMission:addHelpButtonText(g_i18n:getText("MBSTracZndung"), InputBinding.MBSTracZUENDUNG);
	end;
	
	if self.isMotorStarted then	
        if self.motor.speedLevel ~= 0 then
            g_currentMission:addExtraPrintText("Taste NUM +/-:   "..string.format("%d RPM",self.motor.maxRpm[self.motor.speedLevel]).."");
	    else
            g_currentMission:addExtraPrintText("Taste NUM +/-:   "..string.format("%d RPM",self.motor.maxRpm[3]).."");
	    end;
	end;
end;

function MB1800SaddleTrac:onEnter()
    self.compressorStopSoundRunning = true;
	Utils.setEmittingState(self.exhaustParticleLow, false);
end;

function MB1800SaddleTrac:onLeave()
    Utils.setEmittingState(self.exhaustParticleLow, false);
    self.rundumleuchtenAn = false;
    for i=1, self.rundumleuchtenAnz do
       setVisibility(self.rundumleuchten[i].light, self.rundumleuchtenAn);
    end;
	if self.radioSound ~= nil then
        stopSample(self.radioSound);
    end;
	if not self.deactivateOnLeave then
	    self.allowedZuendung = false;
	    self.zuendungKey = true; 
    else
	    self.allowedZuendung = false;
	    self.zuendungKey = false;
	end;
	stopSample(self.compressorSound);
    self.compressorSoundRunning = false;
    self.frontlightsActive = false;
    self.farlightsActive = false;
    self.backlightsActive = false;	
end;

function MB1800SaddleTrac:delete()
  Utils.deleteParticleSystem(self.exhaustParticleLow);
Utils.deleteParticleSystem(self.exhaustParticleHigh);
  --  delete(self.handbrakeSound);
  delete(self.hornSoundId);
  delete(self.radioSound);
  stopSample(self.compressorSound);
	--delete(self.compressorSound);
   -- delete(self.compressorStopSound);
    --delete(self.brakeSound);
    --delete(self.rootNode);
end;

function MB1800SaddleTrac:mouseEvent(posX, posY, isDown, isUp, button)
end;

function key_convert(key)
    if key ~= nil then 
	    local keyname = "";
	    if key > 32 and key < 123 then
	    	keyname = string.upper(string.char(key));
	    elseif key > 255 and key < 266 then
	    	keyname = "NUM "..string.char(key-208);
	    else 
	    	keyname = "";
	    end;
	    return(keyname);
	  end;
end;
--end;